<?php
/**
 * gMap
 *
 * @version 1.0
 * @package gMap
 * @author ZyX (allforjoomla.com)
 * @copyright (C) 2010 by ZyX (http://www.allforjoomla.com)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project,
 * please make a reference to allforjoomla.com someplace in your code
 * and provide a link to http://www.allforjoomla.com
 **/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
if(!class_exists('mosHTML')){
	function mosFormatDate( $date = 'now', $format = null, $offset = null )  {
	
		if ( ! $format )
		{
			$format = JText::_('DATE_FORMAT_LC1');
		}
	
		return JHTML::_('date', $date, $format, $offset);
	}
	JLoader::register('JTableUser', JPATH_LIBRARIES.DS.'joomla'.DS.'database'.DS.'table'.DS.'user.php');
	class mosUser extends JTableUser
	{
		function __construct(&$db)
		{
			parent::__construct( $db );
		}
	
		function mosUser(&$db)
		{
			parent::__construct( $db);
		}
	
		function updateOrder( $where='' )
		{
			return $this->reorder( $where );
		}
	
		function publish_array( $cid=null, $publish=1, $user_id=0 )
		{
			$this->publish( $cid, $publish, $user_id );
		}
	
		function getUserList()
		{
			$this->_db->setQuery("SELECT username FROM #__users");
			return $this->_db->loadAssocList();
		}
	
		function getUserListFromGroup( $value, $name, $recurse='NO_RECURSE', $order='name' )
		{
			$acl =& JFactory::getACL();
	
			// Change back in
			$group_id = $acl->get_group_id( $value, $name, 'ARO');
			$objects = $acl->get_group_objects( $group_id, 'ARO', 'RECURSE');
	
			if (isset( $objects['users'] ))
			{
				$gWhere = '(id =' . implode( ' OR id =', $objects['users'] ) . ')';
	
				$query = 'SELECT id AS value, name AS text'
				. ' FROM #__users'
				. ' WHERE block = "0"'
				. ' AND ' . $gWhere
				. ' ORDER BY '. $order
				;
				$this->_db->setQuery( $query );
				$options = $this->_db->loadObjectList();
				return $options;
			} else {
				return array();
			}
		}
	}
	class mosHTML
	{
		function makeOption( $value, $text='', $value_name='value', $text_name='text' )
		{
			return JHTML::_('select.option', $value, $text, $value_name, $text_name);
		}
	
		function selectList( &$arr, $tag_name, $tag_attribs, $key, $text, $selected=NULL, $idtag=false, $flag=false )
		{
			return JHTML::_('select.genericlist', $arr, $tag_name, $tag_attribs, $key, $text, $selected, $idtag, $flag );
		}
	
		function integerSelectList( $start, $end, $inc, $tag_name, $tag_attribs, $selected, $format="" )
		{
			return JHTML::_('select.integerlist', $start, $end, $inc, $tag_name, $tag_attribs, $selected, $format) ;
		}
	
		function radioList( &$arr, $tag_name, $tag_attribs, $selected=null, $key='value', $text='text', $idtag=false )
		{
			return JHTML::_('select.radiolist', $arr, $tag_name, $tag_attribs, $key, $text,  $selected, $idtag) ;
		}
	
		function yesnoRadioList( $tag_name, $tag_attribs, $selected, $yes='yes', $no='no', $id=false )
		{
			return JHTML::_('select.booleanlist',  $tag_name, $tag_attribs, $selected, $yes, $no, $id ) ;
		}
	
		function yesnoSelectList( $tag_name, $tag_attribs, $selected, $yes='yes', $no='no' )
		{
			$arr = array(
				mosHTML::makeOption( 0, JText::_( $no ) ),
				mosHTML::makeOption( 1, JText::_( $yes ) ),
			);
	
			return mosHTML::selectList( $arr, $tag_name, $tag_attribs, 'value', 'text', (int) $selected );
		}
	
		function idBox( $rowNum, $recId, $checkedOut=false, $name='cid' )
		{
			return JHTML::_('grid.id', $rowNum, $recId, $checkedOut, $name);
		}
	
		function CloseButton ( &$params, $hide_js=NULL )
		{
			if ( $params->get( 'popup' ) && !$hide_js ) {
				?>
				<div align="center" style="margin-top: 30px; margin-bottom: 30px;">
					<script type="text/javascript">
						document.write('<a href="#" onclick="javascript:window.close();"><span class="small"><?php echo JText::_( 'Close Window' );?></span></a>');
					</script>
					<?php
					if ( $_SERVER['HTTP_REFERER'] != "") {
						echo '<noscript>';
						echo '<a href="'. $_SERVER['HTTP_REFERER'] .'"><span class="small">'. JText::_( 'BACK' ) .'</span></a>';
						echo '</noscript>';
					}
					?>
				</div>
				<?php
			}
		}
	
		function BackButton ( &$params, $hide_js=NULL )
		{
			if ( $params->get( 'back_button' ) && !$params->get( 'popup' ) && !$hide_js) {
				?>
				<div class="back_button">
					<a href='javascript:history.go(-1)'>
						<?php echo JText::_( 'BACK' ); ?></a>
				</div>
				<?php
			}
		}
	
		function cleanText ( &$text ) {
			return JFilterOutput::cleanText($text);
		}
	
		function PrintIcon( &$row, &$params, $hide_js, $link, $status=NULL )
		{
	
			if ( $params->get( 'print' )  && !$hide_js ) {
				// use default settings if none declared
				if ( !$status ) {
					$status = 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no';
				}
	
				// checks template image directory for image, if non found default are loaded
				if ( $params->get( 'icons' ) ) {
					$image = mosAdminMenus::ImageCheck( 'printButton.png', '/images/M_images/', NULL, NULL, JText::_( 'Print' ), JText::_( 'Print' ) );
				} else {
					$image = JText::_( 'ICON_SEP' ) .'&nbsp;'. JText::_( 'Print' ) .'&nbsp;'. JText::_( 'ICON_SEP' );
				}
	
				if ( $params->get( 'popup' ) && !$hide_js ) {
					// Print Preview button - used when viewing page
					?>
					<script type="text/javascript">
						document.write('<td align="right" width="100%" class="buttonheading">');
						document.write('<a href="#" onclick="javascript:window.print(); return false" title="<?php echo JText::_( 'Print' );?>">');
						document.write('<?php echo $image;?>');
						document.write('</a>');
						document.write('</td>');
					</script>
					<?php
				} else {
					// Print Button - used in pop-up window
					?>
					<td align="right" width="100%" class="buttonheading">
					<a href="<?php echo $link; ?>" onclick="window.open('<?php echo $link; ?>','win2','<?php echo $status; ?>'); return false;" title="<?php echo JText::_( 'Print' );?>">
						<?php echo $image;?></a>
					</td>
					<?php
				}
			}
		}
	
		function emailCloaking( $mail, $mailto=1, $text='', $email=1 )
		{
			$tmp = JHTML::_('email.cloak', $mail, $mailto, $text, $email);
			$mail 			= JHTMLEmail::_convertEncoding( $mail );
			// split email by @ symbol
			$mail			= explode( '@', $mail );
			$mail_parts		= explode( '.', $mail[1] );
			// random number
			$rand			= rand( 1, 100000 );
	
			$replacement 	= "\n <script type='text/javascript'>";
			$replacement 	.= "\n <!--";
			$replacement 	.= "\n var prefix = '&#109;a' + 'i&#108;' + '&#116;o';";
			$replacement 	.= "\n var path = 'hr' + 'ef' + '=';";
			$replacement 	.= "\n var addy". $rand ." = '". @$mail[0] ."' + '&#64;';";
			$replacement 	.= "\n addy". $rand ." = addy". $rand ." + '". implode( "' + '&#46;' + '", $mail_parts ) ."';";
	
			if ( $mailto ) {
				// special handling when mail text is different from mail addy
				if ( $text ) {
					if ( $email ) {
						// convert text
						$text 			= JHTMLEmail::_convertEncoding( $text );
						// split email by @ symbol
						$text 			= explode( '@', $text );
						$text_parts		= explode( '.', $text[1] );
						$replacement 	.= "\n var addy_text". $rand ." = '". @$text[0] ."' + '&#64;' + '". implode( "' + '&#46;' + '", @$text_parts ) ."';";
					} else {
						$replacement 	.= "\n var addy_text". $rand ." = '". $text ."';";
					}
					$replacement 	.= "\n document.write( '<a ' + path + '\"' + prefix + ':' + addy". $rand ." + '\">' );";
					$replacement 	.= "\n document.write( addy_text". $rand ." );";
					$replacement 	.= "\n document.write( '<\/a>' );";
				} else {
					$replacement 	.= "\n document.write( '<a ' + path + '\'' + prefix + ':' + addy". $rand ." + '\'>' );";
					$replacement 	.= "\n document.write( addy". $rand ." );";
					$replacement 	.= "\n document.write( '<\/a>' );";
				}
			} else {
				$replacement 	.= "\n document.write( addy". $rand ." );";
			}
			$replacement 	.= "\n //-->";
			$replacement 	.= "\n </script> ";
	
			$replacement 	.= "\n <script type='text/javascript'>";
			$replacement 	.= "\n <!--";
			$replacement 	.= "\n".' document.write( "<span style=\'display: none;\'>" );';
			$replacement 	.= "\n //-->";
			$replacement 	.= "\n </script>";
			$replacement 	.= JText::_('CLOAKING');
			$replacement 	.= "\n <script type='text/javascript'>";
			$replacement 	.= "\n <!--";
			$replacement 	.= "\n document.write( '</' );";
			$replacement 	.= "\n document.write( 'span>' );";
			$replacement 	.= "\n //-->";
			$replacement 	.= "\n </script>";
	
			return $replacement;
		}
	
		function keepAlive()
		{
			echo JHTML::_('behavior.keepalive');
		}
	}
	
	class mosDBTable extends JTable
	{
		var $_error = '';
	
		var $_errorNum = 0;
	
		function __construct($table, $key, &$db)
		{
			parent::__construct( $table, $key, $db );
		}
	
		function mosDBTable($table, $key, &$db)
		{
			parent::__construct( $table, $key, $db );
		}
	
		function updateOrder( $where='' )
		{
			return $this->reorder( $where );
		}
	
		function publish_array( $cid=null, $publish=1, $user_id=0 )
		{
			$this->publish( $cid, $publish, $user_id );
		}
	
		function filter( $ignoreList=null )
		{
			$ignore = is_array( $ignoreList );
	
			$filter = & JFilterInput::getInstance();
			foreach ($this->getProperties() as $k => $v)
			{
				if ($ignore && in_array( $k, $ignoreList ) ) {
					continue;
				}
				$this->$k = $filter->clean( $this->$k );
			}
		}
	
		function getPublicProperties()
		{
			$properties = $this->getProperties();
			return array_keys($properties);
		}
	
		function getError($i = null, $toString = true )
		{
			return $this->_error;
		}
	
		function setErrorNum( $value )
		{
			$this->_errorNum = $value;
		}
	
		function getErrorNum()
		{
			return $this->_errorNum;
		}
		#ZyX
		/*function checkin(){
			$db =& $this->getDBO();
			$k = $this->_tbl_key;
			$query = 'UPDATE '.$this->_tbl.' SET checked_out=0 WHERE '.$k.'='.$db->Quote($this->$k);
			$db->setQuery( $query );
			$db->query();
		}*/
		
		function load( $oid=null ){
			$k = $this->_tbl_key;
			//$oid = $this->$k;
			if ($oid === null) {
				return false;
			}
			$this->reset();
			$db =& $this->getDBO();
			$query = 'SELECT *'
			. ' FROM '.$this->_tbl
			. ' WHERE '.$this->_tbl_key.' = '.$db->Quote($oid);
			$db->setQuery( $query );
			if ($result = $db->loadAssoc( )) {
				return $this->bind($result);
			}
			else
			{
				$this->setError( $db->getErrorMsg() );
				return false;
			}
		}
	}
}

##########################################################################################
##########################################################################################
##########################################################################################

class strbmObjType extends mosDBTable{
	var $id = null;
	var $name = null;
	var $icon_name = null;
	var $icon_size = null;
	var $icon_shad_name = null;
	var $icon_shad_size = null;
	var $icon_anchor = null;
	var $info_win_anchor = null;

	function strbmObjType(&$db){
		$this->mosDBTable('#__strb_obj_types', 'id', $db );
	}

	function check($plucked=false) {
		$this->name = trim($this->name);
		if ($this->name == '') {
			$this->_error = _STRBM_ENTER_TYPE_NAME;
			return false;
		}
		return true;
	}

}

class strbmObject extends mosDBTable{
	var $id = null;
	var $obj_type = null;
	var $obj_name = null;
	var $obj_coords = null;
	var $obj_address = null;
	var $short_info = null;
	var $full_info = null;
	var $ordering = null;
	var $created = null;
	var $created_by = null;
	var $created_by_alias = null;
	var $modified = null;
	var $modified_by = null;
	var $modified_by_alias = null;
	var $checked_out = null;
	var $checked_out_time = null;
	var $published = null;

	function strbmObject(&$db){
		$this->mosDBTable('#__strb_objects', 'id', $db );
	}
	
	function getType(){
		$type = new strbmObjType($this->_db);
		if((int)$this->obj_type) $type->load((int)$this->obj_type);
		return $type;
	}

	function check($plucked=false) {
		$this->obj_name = trim($this->obj_name);
		if ($this->obj_name == '') {
			$this->_error = _STRBM_ENTER_OBJ_NAME;
			return false;
		}
		return true;
	}

}

?>