<?php
/**
 * gMap
 *
 * @version 1.0
 * @package gMap
 * @author ZyX (allforjoomla.com)
 * @copyright (C) 2010 by ZyX (http://www.allforjoomla.com)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project,
 * please make a reference to allforjoomla.com someplace in your code
 * and provide a link to http://www.allforjoomla.com
 **/
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

if(!class_exists('mxTemplate')){
	class mxTemplate {
	
		var $template=null;
		var $path=null;
		var $content=null;
		var $output=null;
		var $vars=null;
		var $_tmplpath=null;
		var $_patterns=null;
		var $_replacements=null;
	
		function mxTemplate( $path, $tmpl="" ) {
			if ( file_exists( $path ) ) {
				$this->_tmplpath = $path;
			}
			if ( trim( $tmpl ) ) {
				$this->setTemplate( $tmpl );
			}
		}
	
		function setTemplate( $tmpl ) {
			$this->template = $tmpl;
			$this->path = "$this->_tmplpath/$this->template.tmpl";
			if ( file_exists( $this->path ) ) {
				$this->content = file_get_contents( $this->path );
				return true;
			} else {
				unset( $this->template );
				unset( $this->path );
				return false;
			}
		}
	
		function getTemplate() {
			if ( isset( $this->content ) ) {
				return $this->content;
			} else {
				return false;
			}
		}
	
		function getOutput() {
			if ( isset( $this->output ) ) {
				return $this->output;
			} else {
				return false;
			}
		}
	
		function setVars( $variables ) {
			unset( $this->vars );
			if ( is_array( $variables ) ) {
				$this->vars = $variables;
				return true;
			} else {
				return false;
			}
		}
		
		function addVar( $key, $val ) {
			if ( trim( $key ) && trim( $val ) ) {
				$this->vars[$key] = $val;
				return true;
			} else {
				return false;
			}
		}
	
		function getVars() {
			if ( isset( $this->vars ) ) {
				return $this->vars;
			} else {
				return false;
			}
		}
	
		function parseTemplate( $variables="", $tmpl="" ) {
			if ( $tmpl ) {
				$this->setTemplate( $tmpl );
			}
			if ( $variables ) {
				$this->setVars( $variables );
			}
			if ( isset( $this->content ) ) {
				$this->_patterns['mxtvlaue'] = "/{mxtvalue=([^}]*)}/ie";
				$this->_replacements['mxtvalue'] = "\$this->vars['\\1']";
				$this->_patterns['mxtlang'] = "/{mxtlang=([^}]*)}/ie";
				$this->_replacements['mxtlang'] = "constant('\\1')";
				$this->_patterns['mxtshowif'] = "#{mxtshowif=([^}]*)}(.*){/mxtshowif}#Usie";
				$this->_replacements['mxtshowif'] = "(\$this->vars['\\1']) ? stripslashes('\\2') : ''";
				$this->_patterns['mxtshowifnot'] = "#{mxtshowifnot=([^}]*)}(.*){/mxtshowifnot}#Usie";
				$this->_replacements['mxtshowifnot'] = "(\$this->vars['\\1']) ? '' : stripslashes('\\2')";
				@$this->output = preg_replace( $this->_patterns, $this->_replacements, $this->content );
				return true;
			} else {
				return false;
			}
		}
	
	}

}